# -*- coding: utf-8 -*-
# DO NOT EDIT! This file is auto-generated.
"""
Classes for SystemLink Message Bus usage.
"""
from __future__ import absolute_import

# Import python libs
import json
import sys
from datetime import datetime  # pylint: disable=unused-import

# Import local libs
# pylint: disable=import-error
from systemlink.messagebus.broadcast_message import BroadcastMessage  # pylint: disable=unused-import
from systemlink.messagebus.datetime import from_datetime, to_datetime  # pylint: disable=unused-import
from systemlink.messagebus.message_header import (  # pylint: disable=unused-import
    MessageHeader, JSON_MESSAGE_CONTENT_TYPE, BINARY_MESSAGE_CONTENT_TYPE)
from systemlink.messagebus.message_base import MessageBase
from systemlink.messagebus.request_message import RequestMessage  # pylint: disable=unused-import
from systemlink.messagebus.response_message import ResponseMessage  # pylint: disable=unused-import
from systemlink.messagebus.routed_message import RoutedMessage  # pylint: disable=unused-import
# pylint: enable=import-error

if sys.version_info[0] >= 3:
    long = int  # pylint: disable=redefined-builtin,invalid-name


_PASS_THROUGH_TYPES = {
    'bool',
    'bytearray',
    'float',
    'int',
    'long',
    'object',
    'str'
}

_PRIMITIVE_TYPES = {
    'bool': bool,
    'bytearray': bytearray,
    'datetime': datetime,
    'dict': dict,
    'float': float,
    'int': int,
    'list': list,
    'long': long,
    'object': object,
    'str': str
}


def _str_to_type(type_name):
    """
    Convert a type name to a type.

    :param type_name: The name of the type.
    :type type_name: str
    :return: The corresponding type.
    :rtype: type
    """
    type_ = _PRIMITIVE_TYPES.get(type_name)
    if type_ is not None:
        return type_
    return getattr(sys.modules[__name__], type_name)


def _deserialize(value, type_name):  # pylint: disable=too-many-return-statements,too-many-branches
    """
    Deserialize a value from a Python native type.

    :param value: The value to deserialize.
    :type value: object
    :param type_name: The name of the type of `value``.
    :type type_name: str
    :return: The deserialized object.
    :rtype: object
    """
    if value is None:
        return None
    if not type_name:
        return value
    if type_name.endswith(')'):
        sep_index = type_name.find('(')
        sub_type_name = type_name[sep_index+1:-1]
        type_name = type_name[:sep_index]
        if type_name == 'list':
            if sub_type_name in _PASS_THROUGH_TYPES:
                return value
            return [_deserialize(item, sub_type_name) for item in value]
        assert type_name == 'dict'
        sep_index = sub_type_name.find(',')
        key_type_name = sub_type_name[:sep_index]
        value_type_name = sub_type_name[sep_index+1:].strip()
        if key_type_name in _PASS_THROUGH_TYPES and value_type_name in _PASS_THROUGH_TYPES:
            return value
        new_dict = {}
        for dict_key, dict_value in value.items():
            new_dict[_deserialize(dict_key, key_type_name)] = _deserialize(
                dict_value, value_type_name
            )
        return new_dict
    if type_name in _PASS_THROUGH_TYPES:
        return value
    type_ = _str_to_type(type_name)
    if type_ == datetime:
        if not isinstance(value, datetime):
            return to_datetime(value)
        return value
    if hasattr(type_, 'from_dict'):
        return type_.from_dict(value)
    if hasattr(type_, 'from_string'):
        if isinstance(value, int):
            return type_(value)
        return type_.from_string(value)
    if hasattr(type_, 'from_list'):
        if isinstance(value, int):
            return type_(value)
        return type_.from_list(value)
    return value


def _serialize(value):  # pylint: disable=too-many-return-statements
    """
    Serialize a value to a Python native type.

    :param value: The value to serialize.
    :type value: object
    :return: The serialized object.
    :rtype: object
    """
    if value is None:
        return None
    if isinstance(value, list):
        return [_serialize(item) for item in value]
    if isinstance(value, dict):
        new_dict = {}
        for dict_key, dict_value in value.items():
            new_dict[_serialize(dict_key)] = _serialize(dict_value)
        return new_dict
    if isinstance(value, datetime):
        return from_datetime(value)
    if hasattr(value, 'to_dict'):
        return value.to_dict()
    if hasattr(value, 'to_string'):
        return value.to_string()
    if hasattr(value, 'to_list'):
        return value.to_list()
    return value


# pylint: disable=line-too-long,too-many-lines,too-many-instance-attributes,too-many-arguments,too-many-locals,useless-object-inheritance


#
# TagMessageObjects namespace
#


class DataType(object):  # pylint: disable=too-few-public-methods
    """
    DataType normal enum.
    """
    NONE = 0
    DOUBLE = 1
    INT = 2
    STRING = 3
    BOOLEAN = 4
    U_INT64 = 5
    DATE_TIME = 6
    _INT_TO_STRING = {
        0: 'NONE',
        1: 'DOUBLE',
        2: 'INT',
        3: 'STRING',
        4: 'BOOLEAN',
        5: 'U_INT64',
        6: 'DATE_TIME'
    }
    _STRING_TO_INT = {
        'NONE': 0,
        'DOUBLE': 1,
        'INT': 2,
        'STRING': 3,
        'BOOLEAN': 4,
        'U_INT64': 5,
        'DATE_TIME': 6
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @property
    def value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    @value.setter
    def value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`DataType` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`DataType`.
        :rtype: DataType
        """
        if value_string is None:
            return None
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]

    def __str__(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self.to_string()


class Aggregation(object):  # pylint: disable=too-few-public-methods
    """
    Aggregation normal enum.
    """
    NONE = 0
    ENABLE = 1
    DISABLE = 2
    _INT_TO_STRING = {
        0: 'NONE',
        1: 'ENABLE',
        2: 'DISABLE'
    }
    _STRING_TO_INT = {
        'NONE': 0,
        'ENABLE': 1,
        'DISABLE': 2
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @property
    def value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    @value.setter
    def value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`Aggregation` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`Aggregation`.
        :rtype: Aggregation
        """
        if value_string is None:
            return None
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]

    def __str__(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self.to_string()


class RetentionType(object):  # pylint: disable=too-few-public-methods
    """
    RetentionType normal enum.
    """
    NONE = 0
    DURATION = 1
    COUNT = 2
    PERMANENT = 3
    _INT_TO_STRING = {
        0: 'NONE',
        1: 'DURATION',
        2: 'COUNT',
        3: 'PERMANENT'
    }
    _STRING_TO_INT = {
        'NONE': 0,
        'DURATION': 1,
        'COUNT': 2,
        'PERMANENT': 3
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @property
    def value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    @value.setter
    def value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`RetentionType` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`RetentionType`.
        :rtype: RetentionType
        """
        if value_string is None:
            return None
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]

    def __str__(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self.to_string()


class TagFields(object):  # pylint: disable=too-few-public-methods
    """
    TagFields flags enum.
    """
    KEYWORDS = 1
    PROPERTIES = 2
    COLLECT_AGGREGATES = 4
    _INT_TO_STRING = {
        1: 'KEYWORDS',
        2: 'PROPERTIES',
        4: 'COLLECT_AGGREGATES'
    }
    _STRING_TO_INT = {
        'KEYWORDS': 1,
        'PROPERTIES': 2,
        'COLLECT_AGGREGATES': 4
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @property
    def value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    @value.setter
    def value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_list(cls, value_list):
        """
        Create a new instance of :class:`TagFields` using a list.

        :param value_list: A list of string values for the enum.
        :type value_list: list(str)
        :return: A new instance of :class:`TagFields`.
        :rtype: TagFields
        """
        value = 0
        for value_string in value_list:
            value = value | cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_list(self):
        """
        Returns a list of strings representing the enum.

        :return: A list of strings representing the enum.
        :rtype: list(str)
        """
        value_list = []
        for value_int, value_string in self._INT_TO_STRING:
            if self._value & value_int:
                value_list.append(value_string)
        if not value_list and 0 in self._INT_TO_STRING:
            value_list.append(self._INT_TO_STRING[0])
        return value_list


class SortOrder(object):  # pylint: disable=too-few-public-methods
    """
    SortOrder normal enum.
    """
    ASCENDING = 0
    DESCENDING = 1
    _INT_TO_STRING = {
        0: 'ASCENDING',
        1: 'DESCENDING'
    }
    _STRING_TO_INT = {
        'ASCENDING': 0,
        'DESCENDING': 1
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @property
    def value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    @value.setter
    def value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`SortOrder` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`SortOrder`.
        :rtype: SortOrder
        """
        if value_string is None:
            return None
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]

    def __str__(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self.to_string()


class Tag(object):
    """
    Tag custom data type.
    """
    def __init__(self,
                 path_=None,
                 type_=None,
                 properties_=None,
                 keywords_=None,
                 collect_aggregates_=None):
        """
        :param path_: path
        :type path_: str
        :param type_: type
        :type type_: DataType
        :param properties_: properties
        :type properties_: dict(str,str)
        :param keywords_: keywords
        :type keywords_: list(str)
        :param collect_aggregates_: collect_aggregates
        :type collect_aggregates_: bool
        """
        self.path = path_
        self.type = type_
        self.properties = properties_
        self.keywords = keywords_
        self.collect_aggregates = collect_aggregates_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`Tag` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`Tag`.
        :rtype: Tag
        """
        path_ = _deserialize(body_dict.get('path'), 'str')
        type_ = _deserialize(body_dict.get('type'), 'DataType')
        properties_ = _deserialize(body_dict.get('properties'), 'dict(str,str)')
        keywords_ = _deserialize(body_dict.get('keywords'), 'list(str)')
        collect_aggregates_ = _deserialize(body_dict.get('collectAggregates'), 'bool')
        return cls(
            path_=path_,
            type_=type_,
            properties_=properties_,
            keywords_=keywords_,
            collect_aggregates_=collect_aggregates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`Tag` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`Tag`.
        :rtype: Tag
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`Tag` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`Tag`.
        :rtype: Tag
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        path_ = _serialize(self.path)
        type_ = _serialize(self.type)
        properties_ = _serialize(self.properties)
        keywords_ = _serialize(self.keywords)
        collect_aggregates_ = _serialize(self.collect_aggregates)
        return {
            'path': path_,
            'type': type_,
            'properties': properties_,
            'keywords': keywords_,
            'collectAggregates': collect_aggregates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class PartialTagInfo(object):
    """
    PartialTagInfo custom data type.
    """
    def __init__(self,
                 tag_=None,
                 changes_=None):
        """
        :param tag_: tag
        :type tag_: Tag
        :param changes_: changes
        :type changes_: TagFields
        """
        self.tag = tag_
        self.changes = changes_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`PartialTagInfo` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`PartialTagInfo`.
        :rtype: PartialTagInfo
        """
        tag_ = _deserialize(body_dict.get('tag'), 'Tag')
        changes_ = _deserialize(body_dict.get('changes'), 'TagFields')
        return cls(
            tag_=tag_,
            changes_=changes_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`PartialTagInfo` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`PartialTagInfo`.
        :rtype: PartialTagInfo
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`PartialTagInfo` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`PartialTagInfo`.
        :rtype: PartialTagInfo
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        tag_ = _serialize(self.tag)
        changes_ = _serialize(self.changes)
        return {
            'tag': tag_,
            'changes': changes_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class TypedValue(object):
    """
    TypedValue custom data type.
    """
    def __init__(self,
                 type_=None,
                 value_=None):
        """
        :param type_: type
        :type type_: DataType
        :param value_: value
        :type value_: str
        """
        self.type = type_
        self.value = value_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TypedValue` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TypedValue`.
        :rtype: TypedValue
        """
        type_ = _deserialize(body_dict.get('type'), 'DataType')
        value_ = _deserialize(body_dict.get('value'), 'str')
        return cls(
            type_=type_,
            value_=value_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TypedValue` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TypedValue`.
        :rtype: TypedValue
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TypedValue` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TypedValue`.
        :rtype: TypedValue
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        type_ = _serialize(self.type)
        value_ = _serialize(self.value)
        return {
            'type': type_,
            'value': value_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class TimestampedValue(object):
    """
    TimestampedValue custom data type.
    """
    def __init__(self,
                 timestamp_=None,
                 value_=None):
        """
        :param timestamp_: timestamp
        :type timestamp_: datetime
        :param value_: value
        :type value_: TypedValue
        """
        self.timestamp = timestamp_
        self.value = value_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TimestampedValue` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TimestampedValue`.
        :rtype: TimestampedValue
        """
        timestamp_ = _deserialize(body_dict.get('timestamp'), 'datetime')
        value_ = _deserialize(body_dict.get('value'), 'TypedValue')
        return cls(
            timestamp_=timestamp_,
            value_=value_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TimestampedValue` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TimestampedValue`.
        :rtype: TimestampedValue
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TimestampedValue` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TimestampedValue`.
        :rtype: TimestampedValue
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        timestamp_ = _serialize(self.timestamp)
        value_ = _serialize(self.value)
        return {
            'timestamp': timestamp_,
            'value': value_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class Update(object):
    """
    Update custom data type.
    """
    def __init__(self,
                 path_=None,
                 updates_=None):
        """
        :param path_: path
        :type path_: str
        :param updates_: updates
        :type updates_: list(TimestampedValue)
        """
        self.path = path_
        self.updates = updates_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`Update` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`Update`.
        :rtype: Update
        """
        path_ = _deserialize(body_dict.get('path'), 'str')
        updates_ = _deserialize(body_dict.get('updates'), 'list(TimestampedValue)')
        return cls(
            path_=path_,
            updates_=updates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`Update` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`Update`.
        :rtype: Update
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`Update` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`Update`.
        :rtype: Update
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        path_ = _serialize(self.path)
        updates_ = _serialize(self.updates)
        return {
            'path': path_,
            'updates': updates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class AggregateValue(object):
    """
    AggregateValue custom data type.
    """
    def __init__(self,
                 count_=None,
                 avg_=None,
                 min_=None,
                 max_=None):
        """
        :param count_: count
        :type count_: int
        :param avg_: avg
        :type avg_: float
        :param min_: min
        :type min_: str
        :param max_: max
        :type max_: str
        """
        self.count = count_
        self.avg = avg_
        self.min = min_
        self.max = max_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`AggregateValue` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`AggregateValue`.
        :rtype: AggregateValue
        """
        count_ = _deserialize(body_dict.get('count'), 'int')
        avg_ = _deserialize(body_dict.get('avg'), 'float')
        min_ = _deserialize(body_dict.get('min'), 'str')
        max_ = _deserialize(body_dict.get('max'), 'str')
        return cls(
            count_=count_,
            avg_=avg_,
            min_=min_,
            max_=max_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`AggregateValue` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AggregateValue`.
        :rtype: AggregateValue
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`AggregateValue` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`AggregateValue`.
        :rtype: AggregateValue
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        count_ = _serialize(self.count)
        avg_ = _serialize(self.avg)
        min_ = _serialize(self.min)
        max_ = _serialize(self.max)
        return {
            'count': count_,
            'avg': avg_,
            'min': min_,
            'max': max_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class CurrentValues(object):
    """
    CurrentValues custom data type.
    """
    def __init__(self,
                 path_=None,
                 current_=None,
                 aggregates_=None):
        """
        :param path_: path
        :type path_: str
        :param current_: current
        :type current_: TimestampedValue
        :param aggregates_: aggregates
        :type aggregates_: AggregateValue
        """
        self.path = path_
        self.current = current_
        self.aggregates = aggregates_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`CurrentValues` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`CurrentValues`.
        :rtype: CurrentValues
        """
        path_ = _deserialize(body_dict.get('path'), 'str')
        current_ = _deserialize(body_dict.get('current'), 'TimestampedValue')
        aggregates_ = _deserialize(body_dict.get('aggregates'), 'AggregateValue')
        return cls(
            path_=path_,
            current_=current_,
            aggregates_=aggregates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`CurrentValues` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`CurrentValues`.
        :rtype: CurrentValues
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`CurrentValues` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`CurrentValues`.
        :rtype: CurrentValues
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        path_ = _serialize(self.path)
        current_ = _serialize(self.current)
        aggregates_ = _serialize(self.aggregates)
        return {
            'path': path_,
            'current': current_,
            'aggregates': aggregates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class TimestampedValueWithAggregate(object):
    """
    TimestampedValueWithAggregate custom data type.
    """
    def __init__(self,
                 timestamp_=None,
                 value_=None,
                 aggregates_=None):
        """
        :param timestamp_: timestamp
        :type timestamp_: datetime
        :param value_: value
        :type value_: TypedValue
        :param aggregates_: aggregates
        :type aggregates_: AggregateValue
        """
        self.timestamp = timestamp_
        self.value = value_
        self.aggregates = aggregates_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TimestampedValueWithAggregate` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TimestampedValueWithAggregate`.
        :rtype: TimestampedValueWithAggregate
        """
        timestamp_ = _deserialize(body_dict.get('timestamp'), 'datetime')
        value_ = _deserialize(body_dict.get('value'), 'TypedValue')
        aggregates_ = _deserialize(body_dict.get('aggregates'), 'AggregateValue')
        return cls(
            timestamp_=timestamp_,
            value_=value_,
            aggregates_=aggregates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TimestampedValueWithAggregate` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TimestampedValueWithAggregate`.
        :rtype: TimestampedValueWithAggregate
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TimestampedValueWithAggregate` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TimestampedValueWithAggregate`.
        :rtype: TimestampedValueWithAggregate
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        timestamp_ = _serialize(self.timestamp)
        value_ = _serialize(self.value)
        aggregates_ = _serialize(self.aggregates)
        return {
            'timestamp': timestamp_,
            'value': value_,
            'aggregates': aggregates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class UpdateWithAggregates(object):
    """
    UpdateWithAggregates custom data type.
    """
    def __init__(self,
                 path_=None,
                 updates_=None):
        """
        :param path_: path
        :type path_: str
        :param updates_: updates
        :type updates_: list(TimestampedValueWithAggregate)
        """
        self.path = path_
        self.updates = updates_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`UpdateWithAggregates` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`UpdateWithAggregates`.
        :rtype: UpdateWithAggregates
        """
        path_ = _deserialize(body_dict.get('path'), 'str')
        updates_ = _deserialize(body_dict.get('updates'), 'list(TimestampedValueWithAggregate)')
        return cls(
            path_=path_,
            updates_=updates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`UpdateWithAggregates` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`UpdateWithAggregates`.
        :rtype: UpdateWithAggregates
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`UpdateWithAggregates` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`UpdateWithAggregates`.
        :rtype: UpdateWithAggregates
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        path_ = _serialize(self.path)
        updates_ = _serialize(self.updates)
        return {
            'path': path_,
            'updates': updates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class UpdateWithAggregatesAndMetadata(object):
    """
    UpdateWithAggregatesAndMetadata custom data type.
    """
    def __init__(self,
                 tag_=None,
                 updates_=None):
        """
        :param tag_: tag
        :type tag_: Tag
        :param updates_: updates
        :type updates_: list(TimestampedValueWithAggregate)
        """
        self.tag = tag_
        self.updates = updates_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`UpdateWithAggregatesAndMetadata` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`UpdateWithAggregatesAndMetadata`.
        :rtype: UpdateWithAggregatesAndMetadata
        """
        tag_ = _deserialize(body_dict.get('tag'), 'Tag')
        updates_ = _deserialize(body_dict.get('updates'), 'list(TimestampedValueWithAggregate)')
        return cls(
            tag_=tag_,
            updates_=updates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`UpdateWithAggregatesAndMetadata` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`UpdateWithAggregatesAndMetadata`.
        :rtype: UpdateWithAggregatesAndMetadata
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`UpdateWithAggregatesAndMetadata` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`UpdateWithAggregatesAndMetadata`.
        :rtype: UpdateWithAggregatesAndMetadata
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        tag_ = _serialize(self.tag)
        updates_ = _serialize(self.updates)
        return {
            'tag': tag_,
            'updates': updates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class TagWithValues(object):
    """
    TagWithValues custom data type.
    """
    def __init__(self,
                 tag_=None,
                 current_=None,
                 aggregates_=None):
        """
        :param tag_: tag
        :type tag_: Tag
        :param current_: current
        :type current_: TimestampedValue
        :param aggregates_: aggregates
        :type aggregates_: AggregateValue
        """
        self.tag = tag_
        self.current = current_
        self.aggregates = aggregates_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagWithValues` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TagWithValues`.
        :rtype: TagWithValues
        """
        tag_ = _deserialize(body_dict.get('tag'), 'Tag')
        current_ = _deserialize(body_dict.get('current'), 'TimestampedValue')
        aggregates_ = _deserialize(body_dict.get('aggregates'), 'AggregateValue')
        return cls(
            tag_=tag_,
            current_=current_,
            aggregates_=aggregates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagWithValues` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagWithValues`.
        :rtype: TagWithValues
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagWithValues` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagWithValues`.
        :rtype: TagWithValues
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        tag_ = _serialize(self.tag)
        current_ = _serialize(self.current)
        aggregates_ = _serialize(self.aggregates)
        return {
            'tag': tag_,
            'current': current_,
            'aggregates': aggregates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class Selection(object):
    """
    Selection custom data type.
    """
    def __init__(self,
                 id_=None,
                 search_paths_=None,
                 inactivity_timeout_=None):
        """
        :param id_: id
        :type id_: str
        :param search_paths_: search_paths
        :type search_paths_: list(str)
        :param inactivity_timeout_: inactivity_timeout
        :type inactivity_timeout_: int
        """
        self.id = id_  # pylint: disable=invalid-name
        self.search_paths = search_paths_
        self.inactivity_timeout = inactivity_timeout_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`Selection` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`Selection`.
        :rtype: Selection
        """
        id_ = _deserialize(body_dict.get('id'), 'str')  # pylint: disable=invalid-name
        search_paths_ = _deserialize(body_dict.get('searchPaths'), 'list(str)')
        inactivity_timeout_ = _deserialize(body_dict.get('inactivityTimeout'), 'int')
        return cls(
            id_=id_,
            search_paths_=search_paths_,
            inactivity_timeout_=inactivity_timeout_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`Selection` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`Selection`.
        :rtype: Selection
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`Selection` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`Selection`.
        :rtype: Selection
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        id_ = _serialize(self.id)  # pylint: disable=invalid-name
        search_paths_ = _serialize(self.search_paths)
        inactivity_timeout_ = _serialize(self.inactivity_timeout)
        return {
            'id': id_,
            'searchPaths': search_paths_,
            'inactivityTimeout': inactivity_timeout_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class NodeTagPath(object):
    """
    NodeTagPath custom data type.
    """
    def __init__(self,
                 node_name_=None,
                 tag_path_=None):
        """
        :param node_name_: node_name
        :type node_name_: str
        :param tag_path_: tag_path
        :type tag_path_: str
        """
        self.node_name = node_name_
        self.tag_path = tag_path_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`NodeTagPath` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`NodeTagPath`.
        :rtype: NodeTagPath
        """
        node_name_ = _deserialize(body_dict.get('nodeName'), 'str')
        tag_path_ = _deserialize(body_dict.get('tagPath'), 'str')
        return cls(
            node_name_=node_name_,
            tag_path_=tag_path_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`NodeTagPath` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`NodeTagPath`.
        :rtype: NodeTagPath
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`NodeTagPath` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`NodeTagPath`.
        :rtype: NodeTagPath
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        node_name_ = _serialize(self.node_name)
        tag_path_ = _serialize(self.tag_path)
        return {
            'nodeName': node_name_,
            'tagPath': tag_path_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class SubscriptionValues(object):
    """
    SubscriptionValues custom data type.
    """
    def __init__(self,
                 subscription_id_=None):
        """
        :param subscription_id_: subscription_id
        :type subscription_id_: str
        """
        self.subscription_id = subscription_id_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`SubscriptionValues` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`SubscriptionValues`.
        :rtype: SubscriptionValues
        """
        subscription_id_ = _deserialize(body_dict.get('subscriptionId'), 'str')
        return cls(
            subscription_id_=subscription_id_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SubscriptionValues` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SubscriptionValues`.
        :rtype: SubscriptionValues
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SubscriptionValues` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`SubscriptionValues`.
        :rtype: SubscriptionValues
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        subscription_id_ = _serialize(self.subscription_id)
        return {
            'subscriptionId': subscription_id_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class NodeCurrentValues(object):
    """
    NodeCurrentValues custom data type.
    """
    def __init__(self,
                 node_name_=None,
                 current_values_=None):
        """
        :param node_name_: node_name
        :type node_name_: str
        :param current_values_: current_values
        :type current_values_: list(CurrentValues)
        """
        self.node_name = node_name_
        self.current_values = current_values_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`NodeCurrentValues` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`NodeCurrentValues`.
        :rtype: NodeCurrentValues
        """
        node_name_ = _deserialize(body_dict.get('nodeName'), 'str')
        current_values_ = _deserialize(body_dict.get('currentValues'), 'list(CurrentValues)')
        return cls(
            node_name_=node_name_,
            current_values_=current_values_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`NodeCurrentValues` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`NodeCurrentValues`.
        :rtype: NodeCurrentValues
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`NodeCurrentValues` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`NodeCurrentValues`.
        :rtype: NodeCurrentValues
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        node_name_ = _serialize(self.node_name)
        current_values_ = _serialize(self.current_values)
        return {
            'nodeName': node_name_,
            'currentValues': current_values_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class ErrorEntry(object):
    """
    ErrorEntry custom data type.
    """
    def __init__(self,
                 name_=None,
                 message_=None,
                 args_=None,
                 inner_errors_=None,
                 resource_id_=None,
                 resource_type_=None):
        """
        :param name_: name
        :type name_: str
        :param message_: message
        :type message_: str
        :param args_: args
        :type args_: list(str)
        :param inner_errors_: inner_errors
        :type inner_errors_: list(ErrorEntry)
        :param resource_id_: resource_id
        :type resource_id_: str
        :param resource_type_: resource_type
        :type resource_type_: str
        """
        self.name = name_
        self.message = message_
        self.args = args_
        self.inner_errors = inner_errors_
        self.resource_id = resource_id_
        self.resource_type = resource_type_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`ErrorEntry` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`ErrorEntry`.
        :rtype: ErrorEntry
        """
        name_ = _deserialize(body_dict.get('name'), 'str')
        message_ = _deserialize(body_dict.get('message'), 'str')
        args_ = _deserialize(body_dict.get('args'), 'list(str)')
        inner_errors_ = _deserialize(body_dict.get('innerErrors'), 'list(ErrorEntry)')
        resource_id_ = _deserialize(body_dict.get('resourceId'), 'str')
        resource_type_ = _deserialize(body_dict.get('resourceType'), 'str')
        return cls(
            name_=name_,
            message_=message_,
            args_=args_,
            inner_errors_=inner_errors_,
            resource_id_=resource_id_,
            resource_type_=resource_type_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`ErrorEntry` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`ErrorEntry`.
        :rtype: ErrorEntry
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`ErrorEntry` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`ErrorEntry`.
        :rtype: ErrorEntry
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        name_ = _serialize(self.name)
        message_ = _serialize(self.message)
        args_ = _serialize(self.args)
        inner_errors_ = _serialize(self.inner_errors)
        resource_id_ = _serialize(self.resource_id)
        resource_type_ = _serialize(self.resource_type)
        return {
            'name': name_,
            'message': message_,
            'args': args_,
            'innerErrors': inner_errors_,
            'resourceId': resource_id_,
            'resourceType': resource_type_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


#
# TagIngestion service
#


class TagIngestionJournalEntry(object):
    """
    TagIngestionJournalEntry custom data type.
    """
    def __init__(self,
                 id_=None,
                 created_at_=None,
                 seen_by_=None,
                 update_=None):
        """
        :param id_: id
        :type id_: str
        :param created_at_: created_at
        :type created_at_: datetime
        :param seen_by_: seen_by
        :type seen_by_: list(str)
        :param update_: update
        :type update_: Update
        """
        self.id = id_  # pylint: disable=invalid-name
        self.created_at = created_at_
        self.seen_by = seen_by_
        self.update = update_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagIngestionJournalEntry` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TagIngestionJournalEntry`.
        :rtype: TagIngestionJournalEntry
        """
        id_ = _deserialize(body_dict.get('id'), 'str')  # pylint: disable=invalid-name
        created_at_ = _deserialize(body_dict.get('createdAt'), 'datetime')
        seen_by_ = _deserialize(body_dict.get('seenBy'), 'list(str)')
        update_ = _deserialize(body_dict.get('update'), 'Update')
        return cls(
            id_=id_,
            created_at_=created_at_,
            seen_by_=seen_by_,
            update_=update_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagIngestionJournalEntry` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagIngestionJournalEntry`.
        :rtype: TagIngestionJournalEntry
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagIngestionJournalEntry` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagIngestionJournalEntry`.
        :rtype: TagIngestionJournalEntry
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        id_ = _serialize(self.id)  # pylint: disable=invalid-name
        created_at_ = _serialize(self.created_at)
        seen_by_ = _serialize(self.seen_by)
        update_ = _serialize(self.update)
        return {
            'id': id_,
            'createdAt': created_at_,
            'seenBy': seen_by_,
            'update': update_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class TagUpdateValuesRoutedMessage(RoutedMessage):
    """
    TagUpdateValuesRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TagUpdateValuesRoutedMessage'

    def __init__(self,
                 updates_=None):
        """
        :param updates_: updates
        :type updates_: list(Update)
        """
        self.updates = updates_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagIngestion', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagUpdateValuesRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagUpdateValuesRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagUpdateValuesRoutedMessage`.
        :rtype: TagUpdateValuesRoutedMessage
        """
        updates_ = _deserialize(body_dict.get('updates'), 'list(Update)')
        return cls(
            updates_=updates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagUpdateValuesRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagUpdateValuesRoutedMessage`.
        :rtype: TagUpdateValuesRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagUpdateValuesRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagUpdateValuesRoutedMessage`.
        :rtype: TagUpdateValuesRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagUpdateValuesRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagUpdateValuesRoutedMessage`.
        :rtype: TagUpdateValuesRoutedMessage
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        updates_ = _serialize(self.updates)
        return {
            'updates': updates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagNewTagsIngestedBroadcast(BroadcastMessage):
    """
    TagNewTagsIngestedBroadcast JSON broadcast message.
    """
    MESSAGE_NAME = 'TagNewTagsIngestedBroadcast'

    def __init__(self,
                 updates_=None):
        """
        :param updates_: updates
        :type updates_: list(UpdateWithAggregatesAndMetadata)
        """
        self.updates = updates_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key(None, self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagNewTagsIngestedBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagNewTagsIngestedBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagNewTagsIngestedBroadcast`.
        :rtype: TagNewTagsIngestedBroadcast
        """
        updates_ = _deserialize(body_dict.get('updates'), 'list(UpdateWithAggregatesAndMetadata)')
        return cls(
            updates_=updates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagNewTagsIngestedBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagNewTagsIngestedBroadcast`.
        :rtype: TagNewTagsIngestedBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagNewTagsIngestedBroadcast` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagNewTagsIngestedBroadcast`.
        :rtype: TagNewTagsIngestedBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagNewTagsIngestedBroadcast` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagNewTagsIngestedBroadcast`.
        :rtype: TagNewTagsIngestedBroadcast
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        updates_ = _serialize(self.updates)
        return {
            'updates': updates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagNewJournalsWrittenBroadcast(BroadcastMessage):
    """
    TagNewJournalsWrittenBroadcast JSON broadcast message.
    """
    MESSAGE_NAME = 'TagNewJournalsWrittenBroadcast'

    def __init__(self,
                 journal_ids_=None):
        """
        :param journal_ids_: journal_ids
        :type journal_ids_: list(str)
        """
        self.journal_ids = journal_ids_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key(None, self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagNewJournalsWrittenBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagNewJournalsWrittenBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagNewJournalsWrittenBroadcast`.
        :rtype: TagNewJournalsWrittenBroadcast
        """
        journal_ids_ = _deserialize(body_dict.get('journalIds'), 'list(str)')
        return cls(
            journal_ids_=journal_ids_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagNewJournalsWrittenBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagNewJournalsWrittenBroadcast`.
        :rtype: TagNewJournalsWrittenBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagNewJournalsWrittenBroadcast` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagNewJournalsWrittenBroadcast`.
        :rtype: TagNewJournalsWrittenBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagNewJournalsWrittenBroadcast` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagNewJournalsWrittenBroadcast`.
        :rtype: TagNewJournalsWrittenBroadcast
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        journal_ids_ = _serialize(self.journal_ids)
        return {
            'journalIds': journal_ids_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


#
# TagCurrentValue service
#


class TagCvResetAggregatesRoutedMessage(RoutedMessage):
    """
    TagCvResetAggregatesRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TagCvResetAggregatesRoutedMessage'

    def __init__(self,
                 paths_=None):
        """
        :param paths_: paths
        :type paths_: list(str)
        """
        self.paths = paths_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagCurrentValue', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagCvResetAggregatesRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagCvResetAggregatesRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagCvResetAggregatesRoutedMessage`.
        :rtype: TagCvResetAggregatesRoutedMessage
        """
        paths_ = _deserialize(body_dict.get('paths'), 'list(str)')
        return cls(
            paths_=paths_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagCvResetAggregatesRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagCvResetAggregatesRoutedMessage`.
        :rtype: TagCvResetAggregatesRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagCvResetAggregatesRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagCvResetAggregatesRoutedMessage`.
        :rtype: TagCvResetAggregatesRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagCvResetAggregatesRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagCvResetAggregatesRoutedMessage`.
        :rtype: TagCvResetAggregatesRoutedMessage
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        paths_ = _serialize(self.paths)
        return {
            'paths': paths_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagCvAggregatesResetBroadcast(BroadcastMessage):
    """
    TagCvAggregatesResetBroadcast JSON broadcast message.
    """
    MESSAGE_NAME = 'TagCvAggregatesResetBroadcast'

    def __init__(self,
                 updates_=None):
        """
        :param updates_: updates
        :type updates_: list(UpdateWithAggregates)
        """
        self.updates = updates_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key(None, self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagCvAggregatesResetBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagCvAggregatesResetBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagCvAggregatesResetBroadcast`.
        :rtype: TagCvAggregatesResetBroadcast
        """
        updates_ = _deserialize(body_dict.get('updates'), 'list(UpdateWithAggregates)')
        return cls(
            updates_=updates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagCvAggregatesResetBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagCvAggregatesResetBroadcast`.
        :rtype: TagCvAggregatesResetBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagCvAggregatesResetBroadcast` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagCvAggregatesResetBroadcast`.
        :rtype: TagCvAggregatesResetBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagCvAggregatesResetBroadcast` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagCvAggregatesResetBroadcast`.
        :rtype: TagCvAggregatesResetBroadcast
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        updates_ = _serialize(self.updates)
        return {
            'updates': updates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagCvQueryCurrentValuesByPathRequest(RequestMessage):
    """
    TagCvQueryCurrentValuesByPathRequest JSON request message.
    """
    MESSAGE_NAME = 'TagCvQueryCurrentValuesByPathRequest'

    def __init__(self,
                 paths_=None,
                 allow_stale_=None):
        """
        :param paths_: paths
        :type paths_: list(str)
        :param allow_stale_: allow_stale
        :type allow_stale_: bool
        """
        self.paths = paths_
        self.allow_stale = allow_stale_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagCurrentValue', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagCvQueryCurrentValuesByPathRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathRequest`.
        :rtype: TagCvQueryCurrentValuesByPathRequest
        """
        paths_ = _deserialize(body_dict.get('paths'), 'list(str)')
        allow_stale_ = _deserialize(body_dict.get('allowStale'), 'bool')
        return cls(
            paths_=paths_,
            allow_stale_=allow_stale_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathRequest`.
        :rtype: TagCvQueryCurrentValuesByPathRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathRequest`.
        :rtype: TagCvQueryCurrentValuesByPathRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagCvQueryCurrentValuesByPathRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagCvQueryCurrentValuesByPathRequest`.
        :rtype: TagCvQueryCurrentValuesByPathRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        paths_ = _serialize(self.paths)
        allow_stale_ = _serialize(self.allow_stale)
        return {
            'paths': paths_,
            'allowStale': allow_stale_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagCvQueryCurrentValuesByPathResponse(ResponseMessage):
    """
    TagCvQueryCurrentValuesByPathResponse JSON response message.
    """
    MESSAGE_NAME = 'TagCvQueryCurrentValuesByPathResponse'

    def __init__(self,
                 request_message,
                 values_=None):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param values_: values
        :type values_: list(CurrentValues)
        """
        self.values = values_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super(TagCvQueryCurrentValuesByPathResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathResponse`.
        :rtype: TagCvQueryCurrentValuesByPathResponse
        """
        values_ = _deserialize(body_dict.get('values'), 'list(CurrentValues)')
        return cls(
            request_message,
            values_=values_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathResponse`.
        :rtype: TagCvQueryCurrentValuesByPathResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathResponse`.
        :rtype: TagCvQueryCurrentValuesByPathResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagCvQueryCurrentValuesByPathResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagCvQueryCurrentValuesByPathResponse`.
        :rtype: TagCvQueryCurrentValuesByPathResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        values_ = _serialize(self.values)
        return {
            'values': values_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


#
# TagInfo service
#


class TagInfoCreateTagRoutedMessage(RoutedMessage):
    """
    TagInfoCreateTagRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TagInfoCreateTagRoutedMessage'

    def __init__(self,
                 new_tag_=None):
        """
        :param new_tag_: new_tag
        :type new_tag_: Tag
        """
        self.new_tag = new_tag_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagInfo', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagInfoCreateTagRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagInfoCreateTagRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoCreateTagRoutedMessage`.
        :rtype: TagInfoCreateTagRoutedMessage
        """
        new_tag_ = _deserialize(body_dict.get('newTag'), 'Tag')
        return cls(
            new_tag_=new_tag_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagInfoCreateTagRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoCreateTagRoutedMessage`.
        :rtype: TagInfoCreateTagRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagInfoCreateTagRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagInfoCreateTagRoutedMessage`.
        :rtype: TagInfoCreateTagRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoCreateTagRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoCreateTagRoutedMessage`.
        :rtype: TagInfoCreateTagRoutedMessage
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        new_tag_ = _serialize(self.new_tag)
        return {
            'newTag': new_tag_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagInfoCreateOrUpdateTagsRequest(RequestMessage):
    """
    TagInfoCreateOrUpdateTagsRequest JSON request message.
    """
    MESSAGE_NAME = 'TagInfoCreateOrUpdateTagsRequest'

    def __init__(self,
                 tags_=None,
                 merge_=None):
        """
        :param tags_: tags
        :type tags_: list(PartialTagInfo)
        :param merge_: merge
        :type merge_: bool
        """
        self.tags = tags_
        self.merge = merge_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagInfo', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagInfoCreateOrUpdateTagsRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsRequest`.
        :rtype: TagInfoCreateOrUpdateTagsRequest
        """
        tags_ = _deserialize(body_dict.get('tags'), 'list(PartialTagInfo)')
        merge_ = _deserialize(body_dict.get('merge'), 'bool')
        return cls(
            tags_=tags_,
            merge_=merge_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsRequest`.
        :rtype: TagInfoCreateOrUpdateTagsRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsRequest`.
        :rtype: TagInfoCreateOrUpdateTagsRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoCreateOrUpdateTagsRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoCreateOrUpdateTagsRequest`.
        :rtype: TagInfoCreateOrUpdateTagsRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        tags_ = _serialize(self.tags)
        merge_ = _serialize(self.merge)
        return {
            'tags': tags_,
            'merge': merge_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagInfoCreateOrUpdateTagsResponse(ResponseMessage):
    """
    TagInfoCreateOrUpdateTagsResponse JSON response message.
    """
    MESSAGE_NAME = 'TagInfoCreateOrUpdateTagsResponse'

    def __init__(self,
                 request_message,
                 errors_=None):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param errors_: errors
        :type errors_: ErrorEntry
        """
        self.errors = errors_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super(TagInfoCreateOrUpdateTagsResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsResponse`.
        :rtype: TagInfoCreateOrUpdateTagsResponse
        """
        errors_ = _deserialize(body_dict.get('errors'), 'ErrorEntry')
        return cls(
            request_message,
            errors_=errors_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsResponse`.
        :rtype: TagInfoCreateOrUpdateTagsResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsResponse`.
        :rtype: TagInfoCreateOrUpdateTagsResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoCreateOrUpdateTagsResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoCreateOrUpdateTagsResponse`.
        :rtype: TagInfoCreateOrUpdateTagsResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        errors_ = _serialize(self.errors)
        return {
            'errors': errors_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagInfoUpdateTagRoutedMessage(RoutedMessage):
    """
    TagInfoUpdateTagRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TagInfoUpdateTagRoutedMessage'

    def __init__(self,
                 path_=None,
                 keywords_=None,
                 properties_=None,
                 collect_aggregates_=None,
                 replace_=None):
        """
        :param path_: path
        :type path_: str
        :param keywords_: keywords
        :type keywords_: list(str)
        :param properties_: properties
        :type properties_: dict(str,str)
        :param collect_aggregates_: collect_aggregates
        :type collect_aggregates_: Aggregation
        :param replace_: replace
        :type replace_: bool
        """
        self.path = path_
        self.keywords = keywords_
        self.properties = properties_
        self.collect_aggregates = collect_aggregates_
        self.replace = replace_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagInfo', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagInfoUpdateTagRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagInfoUpdateTagRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoUpdateTagRoutedMessage`.
        :rtype: TagInfoUpdateTagRoutedMessage
        """
        path_ = _deserialize(body_dict.get('path'), 'str')
        keywords_ = _deserialize(body_dict.get('keywords'), 'list(str)')
        properties_ = _deserialize(body_dict.get('properties'), 'dict(str,str)')
        collect_aggregates_ = _deserialize(body_dict.get('collectAggregates'), 'Aggregation')
        replace_ = _deserialize(body_dict.get('replace'), 'bool')
        return cls(
            path_=path_,
            keywords_=keywords_,
            properties_=properties_,
            collect_aggregates_=collect_aggregates_,
            replace_=replace_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagInfoUpdateTagRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoUpdateTagRoutedMessage`.
        :rtype: TagInfoUpdateTagRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagInfoUpdateTagRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagInfoUpdateTagRoutedMessage`.
        :rtype: TagInfoUpdateTagRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoUpdateTagRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoUpdateTagRoutedMessage`.
        :rtype: TagInfoUpdateTagRoutedMessage
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        path_ = _serialize(self.path)
        keywords_ = _serialize(self.keywords)
        properties_ = _serialize(self.properties)
        collect_aggregates_ = _serialize(self.collect_aggregates)
        replace_ = _serialize(self.replace)
        return {
            'path': path_,
            'keywords': keywords_,
            'properties': properties_,
            'collectAggregates': collect_aggregates_,
            'replace': replace_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagInfoDeleteTagsRoutedMessage(RoutedMessage):
    """
    TagInfoDeleteTagsRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TagInfoDeleteTagsRoutedMessage'

    def __init__(self,
                 paths_=None):
        """
        :param paths_: paths
        :type paths_: list(str)
        """
        self.paths = paths_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagInfo', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagInfoDeleteTagsRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagInfoDeleteTagsRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoDeleteTagsRoutedMessage`.
        :rtype: TagInfoDeleteTagsRoutedMessage
        """
        paths_ = _deserialize(body_dict.get('paths'), 'list(str)')
        return cls(
            paths_=paths_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagInfoDeleteTagsRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoDeleteTagsRoutedMessage`.
        :rtype: TagInfoDeleteTagsRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagInfoDeleteTagsRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagInfoDeleteTagsRoutedMessage`.
        :rtype: TagInfoDeleteTagsRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoDeleteTagsRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoDeleteTagsRoutedMessage`.
        :rtype: TagInfoDeleteTagsRoutedMessage
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        paths_ = _serialize(self.paths)
        return {
            'paths': paths_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagInfoQueryTagsRequest(RequestMessage):
    """
    TagInfoQueryTagsRequest JSON request message.
    """
    MESSAGE_NAME = 'TagInfoQueryTagsRequest'

    def __init__(self,
                 search_paths_=None,
                 properties_=None,
                 keywords_=None,
                 skip_=None,
                 take_=None,
                 allow_stale_=None):
        """
        :param search_paths_: search_paths
        :type search_paths_: list(str)
        :param properties_: properties
        :type properties_: dict(str,str)
        :param keywords_: keywords
        :type keywords_: list(str)
        :param skip_: skip
        :type skip_: int
        :param take_: take
        :type take_: int
        :param allow_stale_: allow_stale
        :type allow_stale_: bool
        """
        self.search_paths = search_paths_
        self.properties = properties_
        self.keywords = keywords_
        self.skip = skip_
        self.take = take_
        self.allow_stale = allow_stale_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagInfo', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagInfoQueryTagsRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagInfoQueryTagsRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoQueryTagsRequest`.
        :rtype: TagInfoQueryTagsRequest
        """
        search_paths_ = _deserialize(body_dict.get('searchPaths'), 'list(str)')
        properties_ = _deserialize(body_dict.get('properties'), 'dict(str,str)')
        keywords_ = _deserialize(body_dict.get('keywords'), 'list(str)')
        skip_ = _deserialize(body_dict.get('skip'), 'int')
        take_ = _deserialize(body_dict.get('take'), 'int')
        allow_stale_ = _deserialize(body_dict.get('allowStale'), 'bool')
        return cls(
            search_paths_=search_paths_,
            properties_=properties_,
            keywords_=keywords_,
            skip_=skip_,
            take_=take_,
            allow_stale_=allow_stale_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagInfoQueryTagsRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoQueryTagsRequest`.
        :rtype: TagInfoQueryTagsRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagInfoQueryTagsRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagInfoQueryTagsRequest`.
        :rtype: TagInfoQueryTagsRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoQueryTagsRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoQueryTagsRequest`.
        :rtype: TagInfoQueryTagsRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        search_paths_ = _serialize(self.search_paths)
        properties_ = _serialize(self.properties)
        keywords_ = _serialize(self.keywords)
        skip_ = _serialize(self.skip)
        take_ = _serialize(self.take)
        allow_stale_ = _serialize(self.allow_stale)
        return {
            'searchPaths': search_paths_,
            'properties': properties_,
            'keywords': keywords_,
            'skip': skip_,
            'take': take_,
            'allowStale': allow_stale_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagInfoQueryTagsResponse(ResponseMessage):
    """
    TagInfoQueryTagsResponse JSON response message.
    """
    MESSAGE_NAME = 'TagInfoQueryTagsResponse'

    def __init__(self,
                 request_message,
                 tags_=None,
                 total_count_=None):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param tags_: tags
        :type tags_: list(Tag)
        :param total_count_: total_count
        :type total_count_: int
        """
        self.tags = tags_
        self.total_count = total_count_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super(TagInfoQueryTagsResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagInfoQueryTagsResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoQueryTagsResponse`.
        :rtype: TagInfoQueryTagsResponse
        """
        tags_ = _deserialize(body_dict.get('tags'), 'list(Tag)')
        total_count_ = _deserialize(body_dict.get('totalCount'), 'int')
        return cls(
            request_message,
            tags_=tags_,
            total_count_=total_count_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagInfoQueryTagsResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoQueryTagsResponse`.
        :rtype: TagInfoQueryTagsResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagInfoQueryTagsResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagInfoQueryTagsResponse`.
        :rtype: TagInfoQueryTagsResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoQueryTagsResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoQueryTagsResponse`.
        :rtype: TagInfoQueryTagsResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        tags_ = _serialize(self.tags)
        total_count_ = _serialize(self.total_count)
        return {
            'tags': tags_,
            'totalCount': total_count_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagInfoDeletedTagsBroadcast(BroadcastMessage):
    """
    TagInfoDeletedTagsBroadcast JSON broadcast message.
    """
    MESSAGE_NAME = 'TagInfoDeletedTagsBroadcast'

    def __init__(self,
                 tags_=None):
        """
        :param tags_: tags
        :type tags_: list(str)
        """
        self.tags = tags_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key(None, self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagInfoDeletedTagsBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagInfoDeletedTagsBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoDeletedTagsBroadcast`.
        :rtype: TagInfoDeletedTagsBroadcast
        """
        tags_ = _deserialize(body_dict.get('tags'), 'list(str)')
        return cls(
            tags_=tags_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagInfoDeletedTagsBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoDeletedTagsBroadcast`.
        :rtype: TagInfoDeletedTagsBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagInfoDeletedTagsBroadcast` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagInfoDeletedTagsBroadcast`.
        :rtype: TagInfoDeletedTagsBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoDeletedTagsBroadcast` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoDeletedTagsBroadcast`.
        :rtype: TagInfoDeletedTagsBroadcast
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        tags_ = _serialize(self.tags)
        return {
            'tags': tags_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagInfoTagMetadataUpdatedBroadcast(BroadcastMessage):
    """
    TagInfoTagMetadataUpdatedBroadcast JSON broadcast message.
    """
    MESSAGE_NAME = 'TagInfoTagMetadataUpdatedBroadcast'

    def __init__(self,
                 updated_tag_=None):
        """
        :param updated_tag_: updated_tag
        :type updated_tag_: Tag
        """
        self.updated_tag = updated_tag_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key(None, self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagInfoTagMetadataUpdatedBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagInfoTagMetadataUpdatedBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoTagMetadataUpdatedBroadcast`.
        :rtype: TagInfoTagMetadataUpdatedBroadcast
        """
        updated_tag_ = _deserialize(body_dict.get('updatedTag'), 'Tag')
        return cls(
            updated_tag_=updated_tag_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagInfoTagMetadataUpdatedBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoTagMetadataUpdatedBroadcast`.
        :rtype: TagInfoTagMetadataUpdatedBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagInfoTagMetadataUpdatedBroadcast` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagInfoTagMetadataUpdatedBroadcast`.
        :rtype: TagInfoTagMetadataUpdatedBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoTagMetadataUpdatedBroadcast` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoTagMetadataUpdatedBroadcast`.
        :rtype: TagInfoTagMetadataUpdatedBroadcast
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        updated_tag_ = _serialize(self.updated_tag)
        return {
            'updatedTag': updated_tag_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


#
# TagHttp service
#


class TagHttpGetSelectionsRequest(RequestMessage):
    """
    TagHttpGetSelectionsRequest JSON request message.
    """
    MESSAGE_NAME = 'TagHttpGetSelectionsRequest'

    def __init__(self):
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagHttp', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagHttpGetSelectionsRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`TagHttpGetSelectionsRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHttpGetSelectionsRequest`.
        :rtype: TagHttpGetSelectionsRequest
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHttpGetSelectionsRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpGetSelectionsRequest`.
        :rtype: TagHttpGetSelectionsRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHttpGetSelectionsRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagHttpGetSelectionsRequest`.
        :rtype: TagHttpGetSelectionsRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHttpGetSelectionsRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHttpGetSelectionsRequest`.
        :rtype: TagHttpGetSelectionsRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHttpGetSelectionsResponse(ResponseMessage):
    """
    TagHttpGetSelectionsResponse JSON response message.
    """
    MESSAGE_NAME = 'TagHttpGetSelectionsResponse'

    def __init__(self,
                 request_message,
                 selections_=None):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param selections_: selections
        :type selections_: list(Selection)
        """
        self.selections = selections_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super(TagHttpGetSelectionsResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagHttpGetSelectionsResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHttpGetSelectionsResponse`.
        :rtype: TagHttpGetSelectionsResponse
        """
        selections_ = _deserialize(body_dict.get('selections'), 'list(Selection)')
        return cls(
            request_message,
            selections_=selections_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagHttpGetSelectionsResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpGetSelectionsResponse`.
        :rtype: TagHttpGetSelectionsResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagHttpGetSelectionsResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagHttpGetSelectionsResponse`.
        :rtype: TagHttpGetSelectionsResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHttpGetSelectionsResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHttpGetSelectionsResponse`.
        :rtype: TagHttpGetSelectionsResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        selections_ = _serialize(self.selections)
        return {
            'selections': selections_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHttpGetSelectionRequest(RequestMessage):
    """
    TagHttpGetSelectionRequest JSON request message.
    """
    MESSAGE_NAME = 'TagHttpGetSelectionRequest'

    def __init__(self,
                 id_=None):
        """
        :param id_: id
        :type id_: str
        """
        self.id = id_  # pylint: disable=invalid-name
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagHttp', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagHttpGetSelectionRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHttpGetSelectionRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHttpGetSelectionRequest`.
        :rtype: TagHttpGetSelectionRequest
        """
        id_ = _deserialize(body_dict.get('id'), 'str')  # pylint: disable=invalid-name
        return cls(
            id_=id_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHttpGetSelectionRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpGetSelectionRequest`.
        :rtype: TagHttpGetSelectionRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHttpGetSelectionRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagHttpGetSelectionRequest`.
        :rtype: TagHttpGetSelectionRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHttpGetSelectionRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHttpGetSelectionRequest`.
        :rtype: TagHttpGetSelectionRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        id_ = _serialize(self.id)  # pylint: disable=invalid-name
        return {
            'id': id_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHttpGetSelectionResponse(ResponseMessage):
    """
    TagHttpGetSelectionResponse JSON response message.
    """
    MESSAGE_NAME = 'TagHttpGetSelectionResponse'

    def __init__(self,
                 request_message,
                 selection_=None):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param selection_: selection
        :type selection_: Selection
        """
        self.selection = selection_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super(TagHttpGetSelectionResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagHttpGetSelectionResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHttpGetSelectionResponse`.
        :rtype: TagHttpGetSelectionResponse
        """
        selection_ = _deserialize(body_dict.get('selection'), 'Selection')
        return cls(
            request_message,
            selection_=selection_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagHttpGetSelectionResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpGetSelectionResponse`.
        :rtype: TagHttpGetSelectionResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagHttpGetSelectionResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagHttpGetSelectionResponse`.
        :rtype: TagHttpGetSelectionResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHttpGetSelectionResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHttpGetSelectionResponse`.
        :rtype: TagHttpGetSelectionResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        selection_ = _serialize(self.selection)
        return {
            'selection': selection_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHttpCreateSelectionRequest(RequestMessage):
    """
    TagHttpCreateSelectionRequest JSON request message.
    """
    MESSAGE_NAME = 'TagHttpCreateSelectionRequest'

    def __init__(self,
                 selection_=None):
        """
        :param selection_: selection
        :type selection_: Selection
        """
        self.selection = selection_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagHttp', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagHttpCreateSelectionRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHttpCreateSelectionRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHttpCreateSelectionRequest`.
        :rtype: TagHttpCreateSelectionRequest
        """
        selection_ = _deserialize(body_dict.get('selection'), 'Selection')
        return cls(
            selection_=selection_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHttpCreateSelectionRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpCreateSelectionRequest`.
        :rtype: TagHttpCreateSelectionRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHttpCreateSelectionRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagHttpCreateSelectionRequest`.
        :rtype: TagHttpCreateSelectionRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHttpCreateSelectionRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHttpCreateSelectionRequest`.
        :rtype: TagHttpCreateSelectionRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        selection_ = _serialize(self.selection)
        return {
            'selection': selection_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHttpCreateSelectionResponse(ResponseMessage):
    """
    TagHttpCreateSelectionResponse JSON response message.
    """
    MESSAGE_NAME = 'TagHttpCreateSelectionResponse'

    def __init__(self,
                 request_message,
                 id_=None):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param id_: id
        :type id_: str
        """
        self.id = id_  # pylint: disable=invalid-name
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super(TagHttpCreateSelectionResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagHttpCreateSelectionResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHttpCreateSelectionResponse`.
        :rtype: TagHttpCreateSelectionResponse
        """
        id_ = _deserialize(body_dict.get('id'), 'str')  # pylint: disable=invalid-name
        return cls(
            request_message,
            id_=id_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagHttpCreateSelectionResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpCreateSelectionResponse`.
        :rtype: TagHttpCreateSelectionResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagHttpCreateSelectionResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagHttpCreateSelectionResponse`.
        :rtype: TagHttpCreateSelectionResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHttpCreateSelectionResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHttpCreateSelectionResponse`.
        :rtype: TagHttpCreateSelectionResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        id_ = _serialize(self.id)  # pylint: disable=invalid-name
        return {
            'id': id_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHttpUpdateSelectionRoutedMessage(RoutedMessage):
    """
    TagHttpUpdateSelectionRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TagHttpUpdateSelectionRoutedMessage'

    def __init__(self,
                 selection_=None):
        """
        :param selection_: selection
        :type selection_: Selection
        """
        self.selection = selection_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagHttp', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagHttpUpdateSelectionRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHttpUpdateSelectionRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHttpUpdateSelectionRoutedMessage`.
        :rtype: TagHttpUpdateSelectionRoutedMessage
        """
        selection_ = _deserialize(body_dict.get('selection'), 'Selection')
        return cls(
            selection_=selection_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHttpUpdateSelectionRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpUpdateSelectionRoutedMessage`.
        :rtype: TagHttpUpdateSelectionRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHttpUpdateSelectionRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagHttpUpdateSelectionRoutedMessage`.
        :rtype: TagHttpUpdateSelectionRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHttpUpdateSelectionRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHttpUpdateSelectionRoutedMessage`.
        :rtype: TagHttpUpdateSelectionRoutedMessage
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        selection_ = _serialize(self.selection)
        return {
            'selection': selection_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHttpDeleteSelectionRoutedMessage(RoutedMessage):
    """
    TagHttpDeleteSelectionRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TagHttpDeleteSelectionRoutedMessage'

    def __init__(self,
                 id_=None):
        """
        :param id_: id
        :type id_: str
        """
        self.id = id_  # pylint: disable=invalid-name
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagHttp', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagHttpDeleteSelectionRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHttpDeleteSelectionRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHttpDeleteSelectionRoutedMessage`.
        :rtype: TagHttpDeleteSelectionRoutedMessage
        """
        id_ = _deserialize(body_dict.get('id'), 'str')  # pylint: disable=invalid-name
        return cls(
            id_=id_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHttpDeleteSelectionRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpDeleteSelectionRoutedMessage`.
        :rtype: TagHttpDeleteSelectionRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHttpDeleteSelectionRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagHttpDeleteSelectionRoutedMessage`.
        :rtype: TagHttpDeleteSelectionRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHttpDeleteSelectionRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHttpDeleteSelectionRoutedMessage`.
        :rtype: TagHttpDeleteSelectionRoutedMessage
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        id_ = _serialize(self.id)  # pylint: disable=invalid-name
        return {
            'id': id_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


#
# TagSubscriptionCommunicator service
#


class UpdateMode(object):  # pylint: disable=too-few-public-methods
    """
    UpdateMode normal enum.
    """
    POLL = 0
    IMMEDIATE_NOTIFICATION = 1
    BATCH = 2
    _INT_TO_STRING = {
        0: 'POLL',
        1: 'IMMEDIATE_NOTIFICATION',
        2: 'BATCH'
    }
    _STRING_TO_INT = {
        'POLL': 0,
        'IMMEDIATE_NOTIFICATION': 1,
        'BATCH': 2
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @property
    def value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    @value.setter
    def value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`UpdateMode` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`UpdateMode`.
        :rtype: UpdateMode
        """
        if value_string is None:
            return None
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]

    def __str__(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self.to_string()


class SubscriptionOptions(object):
    """
    SubscriptionOptions custom data type.
    """
    def __init__(self,
                 update_mode_=None,
                 updates_only_=None,
                 batch_interval_seconds_=None):
        """
        :param update_mode_: update_mode
        :type update_mode_: UpdateMode
        :param updates_only_: updates_only
        :type updates_only_: bool
        :param batch_interval_seconds_: batch_interval_seconds
        :type batch_interval_seconds_: int
        """
        self.update_mode = update_mode_
        self.updates_only = updates_only_
        self.batch_interval_seconds = batch_interval_seconds_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`SubscriptionOptions` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`SubscriptionOptions`.
        :rtype: SubscriptionOptions
        """
        update_mode_ = _deserialize(body_dict.get('updateMode'), 'UpdateMode')
        updates_only_ = _deserialize(body_dict.get('updatesOnly'), 'bool')
        batch_interval_seconds_ = _deserialize(body_dict.get('batchIntervalSeconds'), 'int')
        return cls(
            update_mode_=update_mode_,
            updates_only_=updates_only_,
            batch_interval_seconds_=batch_interval_seconds_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SubscriptionOptions` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SubscriptionOptions`.
        :rtype: SubscriptionOptions
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SubscriptionOptions` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`SubscriptionOptions`.
        :rtype: SubscriptionOptions
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        update_mode_ = _serialize(self.update_mode)
        updates_only_ = _serialize(self.updates_only)
        batch_interval_seconds_ = _serialize(self.batch_interval_seconds)
        return {
            'updateMode': update_mode_,
            'updatesOnly': updates_only_,
            'batchIntervalSeconds': batch_interval_seconds_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class SubscriptionUpdate(object):
    """
    SubscriptionUpdate custom data type.
    """
    def __init__(self,
                 subscription_id_=None,
                 alias_=None,
                 updates_=None,
                 created_tags_=None,
                 deleted_tags_=None,
                 nonexistent_tags_=None):
        """
        :param subscription_id_: subscription_id
        :type subscription_id_: str
        :param alias_: alias
        :type alias_: str
        :param updates_: updates
        :type updates_: list(UpdateWithAggregatesAndMetadata)
        :param created_tags_: created_tags
        :type created_tags_: list(str)
        :param deleted_tags_: deleted_tags
        :type deleted_tags_: list(str)
        :param nonexistent_tags_: nonexistent_tags
        :type nonexistent_tags_: list(str)
        """
        self.subscription_id = subscription_id_
        self.alias = alias_
        self.updates = updates_
        self.created_tags = created_tags_
        self.deleted_tags = deleted_tags_
        self.nonexistent_tags = nonexistent_tags_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`SubscriptionUpdate` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`SubscriptionUpdate`.
        :rtype: SubscriptionUpdate
        """
        subscription_id_ = _deserialize(body_dict.get('subscriptionId'), 'str')
        alias_ = _deserialize(body_dict.get('alias'), 'str')
        updates_ = _deserialize(body_dict.get('updates'), 'list(UpdateWithAggregatesAndMetadata)')
        created_tags_ = _deserialize(body_dict.get('createdTags'), 'list(str)')
        deleted_tags_ = _deserialize(body_dict.get('deletedTags'), 'list(str)')
        nonexistent_tags_ = _deserialize(body_dict.get('nonexistentTags'), 'list(str)')
        return cls(
            subscription_id_=subscription_id_,
            alias_=alias_,
            updates_=updates_,
            created_tags_=created_tags_,
            deleted_tags_=deleted_tags_,
            nonexistent_tags_=nonexistent_tags_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SubscriptionUpdate` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SubscriptionUpdate`.
        :rtype: SubscriptionUpdate
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SubscriptionUpdate` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`SubscriptionUpdate`.
        :rtype: SubscriptionUpdate
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        subscription_id_ = _serialize(self.subscription_id)
        alias_ = _serialize(self.alias)
        updates_ = _serialize(self.updates)
        created_tags_ = _serialize(self.created_tags)
        deleted_tags_ = _serialize(self.deleted_tags)
        nonexistent_tags_ = _serialize(self.nonexistent_tags)
        return {
            'subscriptionId': subscription_id_,
            'alias': alias_,
            'updates': updates_,
            'createdTags': created_tags_,
            'deletedTags': deleted_tags_,
            'nonexistentTags': nonexistent_tags_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class TagSubscriptionCommunicatorSubscribeRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorSubscribeRequest JSON request message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorSubscribeRequest'

    def __init__(self,
                 alias_=None,
                 options_=None,
                 tags_=None):
        """
        :param alias_: alias
        :type alias_: str
        :param options_: options
        :type options_: SubscriptionOptions
        :param tags_: tags
        :type tags_: list(str)
        """
        self.alias = alias_
        self.options = options_
        self.tags = tags_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagSubscriptionCommunicatorSubscribeRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorSubscribeRequest
        """
        alias_ = _deserialize(body_dict.get('alias'), 'str')
        options_ = _deserialize(body_dict.get('options'), 'SubscriptionOptions')
        tags_ = _deserialize(body_dict.get('tags'), 'list(str)')
        return cls(
            alias_=alias_,
            options_=options_,
            tags_=tags_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorSubscribeRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorSubscribeRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorSubscribeRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorSubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorSubscribeRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        alias_ = _serialize(self.alias)
        options_ = _serialize(self.options)
        tags_ = _serialize(self.tags)
        return {
            'alias': alias_,
            'options': options_,
            'tags': tags_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorSubscribeResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorSubscribeResponse JSON response message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorSubscribeResponse'

    def __init__(self,
                 request_message,
                 subscription_id_=None,
                 alias_=None,
                 nonexistent_tags_=None):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param subscription_id_: subscription_id
        :type subscription_id_: str
        :param alias_: alias
        :type alias_: str
        :param nonexistent_tags_: nonexistent_tags
        :type nonexistent_tags_: list(str)
        """
        self.subscription_id = subscription_id_
        self.alias = alias_
        self.nonexistent_tags = nonexistent_tags_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super(TagSubscriptionCommunicatorSubscribeResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorSubscribeResponse
        """
        subscription_id_ = _deserialize(body_dict.get('subscriptionId'), 'str')
        alias_ = _deserialize(body_dict.get('alias'), 'str')
        nonexistent_tags_ = _deserialize(body_dict.get('nonexistentTags'), 'list(str)')
        return cls(
            request_message,
            subscription_id_=subscription_id_,
            alias_=alias_,
            nonexistent_tags_=nonexistent_tags_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorSubscribeResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorSubscribeResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorSubscribeResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorSubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorSubscribeResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        subscription_id_ = _serialize(self.subscription_id)
        alias_ = _serialize(self.alias)
        nonexistent_tags_ = _serialize(self.nonexistent_tags)
        return {
            'subscriptionId': subscription_id_,
            'alias': alias_,
            'nonexistentTags': nonexistent_tags_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorGetSubscriptionRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorGetSubscriptionRequest JSON request message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorGetSubscriptionRequest'

    def __init__(self,
                 subscription_id_=None):
        """
        :param subscription_id_: subscription_id
        :type subscription_id_: str
        """
        self.subscription_id = subscription_id_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagSubscriptionCommunicatorGetSubscriptionRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionRequest
        """
        subscription_id_ = _deserialize(body_dict.get('subscriptionId'), 'str')
        return cls(
            subscription_id_=subscription_id_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetSubscriptionRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorGetSubscriptionRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        subscription_id_ = _serialize(self.subscription_id)
        return {
            'subscriptionId': subscription_id_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorGetSubscriptionResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorGetSubscriptionResponse JSON response message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorGetSubscriptionResponse'

    def __init__(self,
                 request_message,
                 valid_subscription_=None,
                 alias_=None,
                 options_=None,
                 tags_=None):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param valid_subscription_: valid_subscription
        :type valid_subscription_: bool
        :param alias_: alias
        :type alias_: str
        :param options_: options
        :type options_: SubscriptionOptions
        :param tags_: tags
        :type tags_: list(str)
        """
        self.valid_subscription = valid_subscription_
        self.alias = alias_
        self.options = options_
        self.tags = tags_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super(TagSubscriptionCommunicatorGetSubscriptionResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionResponse
        """
        valid_subscription_ = _deserialize(body_dict.get('validSubscription'), 'bool')
        alias_ = _deserialize(body_dict.get('alias'), 'str')
        options_ = _deserialize(body_dict.get('options'), 'SubscriptionOptions')
        tags_ = _deserialize(body_dict.get('tags'), 'list(str)')
        return cls(
            request_message,
            valid_subscription_=valid_subscription_,
            alias_=alias_,
            options_=options_,
            tags_=tags_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetSubscriptionResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorGetSubscriptionResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        valid_subscription_ = _serialize(self.valid_subscription)
        alias_ = _serialize(self.alias)
        options_ = _serialize(self.options)
        tags_ = _serialize(self.tags)
        return {
            'validSubscription': valid_subscription_,
            'alias': alias_,
            'options': options_,
            'tags': tags_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorGetSubscriptionsRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorGetSubscriptionsRequest JSON request message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorGetSubscriptionsRequest'

    def __init__(self):
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagSubscriptionCommunicatorGetSubscriptionsRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsRequest
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetSubscriptionsRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorGetSubscriptionsRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorGetSubscriptionsResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorGetSubscriptionsResponse JSON response message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorGetSubscriptionsResponse'

    def __init__(self,
                 request_message,
                 subscription_ids_=None):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param subscription_ids_: subscription_ids
        :type subscription_ids_: list(str)
        """
        self.subscription_ids = subscription_ids_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super(TagSubscriptionCommunicatorGetSubscriptionsResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsResponse
        """
        subscription_ids_ = _deserialize(body_dict.get('subscriptionIds'), 'list(str)')
        return cls(
            request_message,
            subscription_ids_=subscription_ids_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetSubscriptionsResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorGetSubscriptionsResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        subscription_ids_ = _serialize(self.subscription_ids)
        return {
            'subscriptionIds': subscription_ids_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorUnsubscribeRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorUnsubscribeRequest JSON request message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorUnsubscribeRequest'

    def __init__(self,
                 subscription_ids_=None):
        """
        :param subscription_ids_: subscription_ids
        :type subscription_ids_: list(str)
        """
        self.subscription_ids = subscription_ids_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagSubscriptionCommunicatorUnsubscribeRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeRequest
        """
        subscription_ids_ = _deserialize(body_dict.get('subscriptionIds'), 'list(str)')
        return cls(
            subscription_ids_=subscription_ids_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorUnsubscribeRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorUnsubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        subscription_ids_ = _serialize(self.subscription_ids)
        return {
            'subscriptionIds': subscription_ids_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorUnsubscribeResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorUnsubscribeResponse JSON response message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorUnsubscribeResponse'

    def __init__(self,
                 request_message,
                 invalid_subscription_ids_=None):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param invalid_subscription_ids_: invalid_subscription_ids
        :type invalid_subscription_ids_: list(str)
        """
        self.invalid_subscription_ids = invalid_subscription_ids_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super(TagSubscriptionCommunicatorUnsubscribeResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeResponse
        """
        invalid_subscription_ids_ = _deserialize(body_dict.get('invalidSubscriptionIds'), 'list(str)')
        return cls(
            request_message,
            invalid_subscription_ids_=invalid_subscription_ids_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorUnsubscribeResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorUnsubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        invalid_subscription_ids_ = _serialize(self.invalid_subscription_ids)
        return {
            'invalidSubscriptionIds': invalid_subscription_ids_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorSubscriptionHeartbeatRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorSubscriptionHeartbeatRequest JSON request message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorSubscriptionHeartbeatRequest'

    def __init__(self,
                 subscription_ids_=None):
        """
        :param subscription_ids_: subscription_ids
        :type subscription_ids_: list(str)
        """
        self.subscription_ids = subscription_ids_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagSubscriptionCommunicatorSubscriptionHeartbeatRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatRequest
        """
        subscription_ids_ = _deserialize(body_dict.get('subscriptionIds'), 'list(str)')
        return cls(
            subscription_ids_=subscription_ids_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        subscription_ids_ = _serialize(self.subscription_ids)
        return {
            'subscriptionIds': subscription_ids_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorSubscriptionHeartbeatResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorSubscriptionHeartbeatResponse JSON response message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorSubscriptionHeartbeatResponse'

    def __init__(self,
                 request_message,
                 invalid_subscription_ids_=None):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param invalid_subscription_ids_: invalid_subscription_ids
        :type invalid_subscription_ids_: list(str)
        """
        self.invalid_subscription_ids = invalid_subscription_ids_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super(TagSubscriptionCommunicatorSubscriptionHeartbeatResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatResponse
        """
        invalid_subscription_ids_ = _deserialize(body_dict.get('invalidSubscriptionIds'), 'list(str)')
        return cls(
            request_message,
            invalid_subscription_ids_=invalid_subscription_ids_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        invalid_subscription_ids_ = _serialize(self.invalid_subscription_ids)
        return {
            'invalidSubscriptionIds': invalid_subscription_ids_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorGetUpdatesRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorGetUpdatesRequest JSON request message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorGetUpdatesRequest'

    def __init__(self,
                 subscription_ids_=None):
        """
        :param subscription_ids_: subscription_ids
        :type subscription_ids_: list(str)
        """
        self.subscription_ids = subscription_ids_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagSubscriptionCommunicatorGetUpdatesRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesRequest
        """
        subscription_ids_ = _deserialize(body_dict.get('subscriptionIds'), 'list(str)')
        return cls(
            subscription_ids_=subscription_ids_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetUpdatesRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorGetUpdatesRequest`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        subscription_ids_ = _serialize(self.subscription_ids)
        return {
            'subscriptionIds': subscription_ids_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorGetUpdatesResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorGetUpdatesResponse JSON response message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorGetUpdatesResponse'

    def __init__(self,
                 request_message,
                 updates_=None,
                 invalid_subscription_ids_=None):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param updates_: updates
        :type updates_: list(SubscriptionUpdate)
        :param invalid_subscription_ids_: invalid_subscription_ids
        :type invalid_subscription_ids_: list(str)
        """
        self.updates = updates_
        self.invalid_subscription_ids = invalid_subscription_ids_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super(TagSubscriptionCommunicatorGetUpdatesResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesResponse
        """
        updates_ = _deserialize(body_dict.get('updates'), 'list(SubscriptionUpdate)')
        invalid_subscription_ids_ = _deserialize(body_dict.get('invalidSubscriptionIds'), 'list(str)')
        return cls(
            request_message,
            updates_=updates_,
            invalid_subscription_ids_=invalid_subscription_ids_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetUpdatesResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorGetUpdatesResponse`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        updates_ = _serialize(self.updates)
        invalid_subscription_ids_ = _serialize(self.invalid_subscription_ids)
        return {
            'updates': updates_,
            'invalidSubscriptionIds': invalid_subscription_ids_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorMessageWrapperRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorMessageWrapperRequest JSON request message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorMessageWrapperRequest'

    def __init__(self):
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagSubscriptionCommunicatorMessageWrapperRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorMessageWrapperRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorMessageWrapperRequest`.
        :rtype: TagSubscriptionCommunicatorMessageWrapperRequest
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorMessageWrapperRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorMessageWrapperRequest`.
        :rtype: TagSubscriptionCommunicatorMessageWrapperRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorMessageWrapperRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagSubscriptionCommunicatorMessageWrapperRequest`.
        :rtype: TagSubscriptionCommunicatorMessageWrapperRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorMessageWrapperRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorMessageWrapperRequest`.
        :rtype: TagSubscriptionCommunicatorMessageWrapperRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorMessageWrapperResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorMessageWrapperResponse binary response message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorMessageWrapperResponse'

    def __init__(self,
                 request_message,
                 body=None):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :param body: The binary message body
        :type body: bytes or bytearray
        """
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = BINARY_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super(TagSubscriptionCommunicatorMessageWrapperResponse, self).__init__(header, body)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorMessageWrapperResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorMessageWrapperResponse`.
        :rtype: TagSubscriptionCommunicatorMessageWrapperResponse
        """
        source_body = message.body_bytes
        instance = cls(
            message,
            source_body
        )
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.body_bytes
        return MessageBase(header, body_bytes)


class TagSubscriptionCommunicatorPushedUpdateRoutedMessage(RoutedMessage):
    """
    TagSubscriptionCommunicatorPushedUpdateRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorPushedUpdateRoutedMessage'

    def __init__(self,
                 routing_source,
                 updates_=None):
        """
        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: systemlink.messagebus.message_base.MessageBase
        :param updates_: updates
        :type updates_: list(SubscriptionUpdate)
        """
        self.updates = updates_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key(routing_source.reply_to, self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(TagSubscriptionCommunicatorPushedUpdateRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, routing_source, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage` using a dictionary.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: systemlink.messagebus.message_base.MessageBase
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage`.
        :rtype: TagSubscriptionCommunicatorPushedUpdateRoutedMessage
        """
        updates_ = _deserialize(body_dict.get('updates'), 'list(SubscriptionUpdate)')
        return cls(
            routing_source,
            updates_=updates_
        )

    @classmethod
    def from_json(cls, routing_source, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage` using a JSON string.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: systemlink.messagebus.message_base.MessageBase
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage`.
        :rtype: TagSubscriptionCommunicatorPushedUpdateRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(routing_source, body_dict)

    @classmethod
    def from_body_bytes(cls, routing_source, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: systemlink.messagebus.message_base.MessageBase
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage`.
        :rtype: TagSubscriptionCommunicatorPushedUpdateRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(routing_source, body_json)

    @classmethod
    def from_message(cls, routing_source, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorPushedUpdateRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: systemlink.messagebus.message_base.MessageBase
        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorPushedUpdateRoutedMessage`.
        :rtype: TagSubscriptionCommunicatorPushedUpdateRoutedMessage
        """
        instance = cls.from_body_bytes(routing_source, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        updates_ = _serialize(self.updates)
        return {
            'updates': updates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, routing_source, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: systemlink.messagebus.message_base.MessageBase
        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(routing_source.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body
